---
name: Terra Improvement Proposal (TIP)
about: Use this template to outline proposed changes to the Terra core.
title: 'TIP # __ Your Title Here'
labels: ''
assignees: ''

---

<!---Include the TIP number in the title as follows: TIP # 01 Your Title Here-->
**TIP #**:

**Author**:  
**Network**: <!---Add the mainnet version this change will apply to. -->
**Date**: 

## Summary

<!--- A 1-2 sentence non-technical explanation of the change. Summaries should be easily understood by the general community. -->



## Motivation

<!--- An explanation of why the change is necessary. What is the problem that needs to be solved? Why do these changes need to be implemented? -->

## Tech Spec

**Modules:** <!--- List affected modules with short notes on alterations. --> 
-  
-  
-  
### Overview

<!---A technical summary of the change and how it will solve the problem. --> 


### Rationale

<!--- Why are you doing it this way and not another way? What is the reasoning for using this method vs another route? -->


### Method

<!--- An outline of how the change will be implemented. This can include a numbered list of steps necessary for completion. -->

1. 
2. 
3. 

### Code

<!--- Include any applicable code blocks or pseudocode describing the changes. -->

### Considerations

<!--- Describe any special or general considerations. Is there anything that you should be cautious about? Are there any invariants to keep in mind? -->

## Timeline

<!--- If applicable, include an estimated project completion time. You can break this up into a list of events. -->

## Test cases

<!--- If applicable, include any test cases or preliminary research related to the change. -->